Loading...
Searching...
No Matches
juce::ComboBox Class Reference

## Detailed Description

A component that lets the user choose from a drop-down list of choices.

The combo-box has a list of text strings, each with an associated id number, that will be shown in the drop-down list when the user clicks on the component.

The currently selected choice is displayed in the combo-box, and this can either be read-only text, or editable.

To find out when the user selects a different item or edits the text, you can assign a lambda to the onChange member, or register a ComboBox::Listener to receive callbacks.

The documentation for this class was generated from the following file:

- juce_gui_basics/widgets/juce_ComboBox.h

Inheritance diagram for juce::ComboBox:

## Classes

class | Listener
| A class for receiving events from a ComboBox. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide ComboBox functionality. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1000b00 , textColourId = 0x1000a00 , outlineColourId = 0x1000c00 , buttonColourId = 0x1000d00 , arrowColourId = 0x1000e00 , focusedOutlineColourId = 0x1000f00 }
| A set of colour IDs to use to change the colour of various aspects of the combo box. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| ComboBox (const String &componentName={})
| Creates a combo-box.
| ~ComboBox () override
| Destructor.
void | setEditableText (bool isEditable)
| Sets whether the text in the combo-box is editable.
bool | isTextEditable () const noexcept
| Returns true if the text is directly editable.
void | setJustificationType (Justification justification)
| Sets the style of justification to be used for positioning the text.
Justification | getJustificationType () const noexcept
| Returns the current justification for the text box.
void | addItem (const String &newItemText, int newItemId)
| Adds an item to be shown in the drop-down list.
void | addItemList (const StringArray &items, int firstItemIdOffset)
| Adds an array of items to the drop-down list.
void | addSeparator ()
| Adds a separator line to the drop-down list.
void | addSectionHeading (const String &headingName)
| Adds a heading to the drop-down list, so that you can group the items into different sections.
void | setItemEnabled (int itemId, bool shouldBeEnabled)
| This allows items in the drop-down list to be selectively disabled.
bool | isItemEnabled (int itemId) const noexcept
| Returns true if the given item is enabled.
void | changeItemText (int itemId, const String &newText)
| Changes the text for an existing item.
void | clear (NotificationType notification=sendNotificationAsync)
| Removes all the items from the drop-down list.
int | getNumItems () const noexcept
| Returns the number of items that have been added to the list.
String | getItemText (int index) const
| Returns the text for one of the items in the list.
int | getItemId (int index) const noexcept
| Returns the ID for one of the items in the list.
int | indexOfItemId (int itemId) const noexcept
| Returns the index in the list of a particular item ID.
int | getSelectedId () const noexcept
| Returns the ID of the item that's currently shown in the box.
Value & | getSelectedIdAsValue ()
| Returns a Value object that can be used to get or set the selected item's ID.
void | setSelectedId (int newItemId, NotificationType notification=sendNotificationAsync)
| Sets one of the items to be the current selection.
int | getSelectedItemIndex () const
| Returns the index of the item that's currently shown in the box.
void | setSelectedItemIndex (int newItemIndex, NotificationType notification=sendNotificationAsync)
| Sets one of the items to be the current selection.
String | getText () const
| Returns the text that is currently shown in the combo-box's text field.
void | setText (const String &newText, NotificationType notification=sendNotificationAsync)
| Sets the contents of the combo-box's text field.
void | showEditor ()
| Programmatically opens the text editor to allow the user to edit the current item.
virtual void | showPopup ()
| Pops up the combo box's list.
void | hidePopup ()
| Hides the combo box's popup list, if it's currently visible.
bool | isPopupActive () const noexcept
| Returns true if the popup menu is currently being shown.
PopupMenu * | getRootMenu () noexcept
| Returns the PopupMenu object associated with the ComboBox.
const PopupMenu * | getRootMenu () const noexcept
| Returns the PopupMenu object associated with the ComboBox.
void | addListener (Listener *listener)
| Registers a listener that will be called when the box's content changes.
void | removeListener (Listener *listener)
| Deregisters a previously-registered listener.
void | setTextWhenNothingSelected (const String &newMessage)
| Sets a message to display when there is no item currently selected.
String | getTextWhenNothingSelected () const
| Returns the text that is shown when no item is selected.
void | setTextWhenNoChoicesAvailable (const String &newMessage)
| Sets the message to show when there are no items in the list, and the user clicks on the drop-down box.
String | getTextWhenNoChoicesAvailable () const
| Returns the text shown when no items have been added to the list.
void | setTooltip (const String &newTooltip) override
| Gives the ComboBox a tooltip.
void | setScrollWheelEnabled (bool enabled) noexcept
| This can be used to allow the scroll-wheel to nudge the chosen item.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void | focusGained (Component::FocusChangeType) override
| Called to indicate that this component has just acquired the keyboard focus.
void | focusLost (Component::FocusChangeType) override
| Called to indicate that this component has just lost the keyboard focus.
void | handleAsyncUpdate () override
| Called back to do whatever your class needs to do.
String | getTooltip () override
| Returns the string that this object wants to show as its tooltip.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
bool | keyStateChanged (bool) override
| Called when a key is pressed or released.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | valueChanged (Value &) override
| Called when a Value object is changed.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from juce::TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.
Public Member Functions inherited from juce::Value::Listener
| Listener ()=default
virtual | ~Listener ()=default

## Public Attributes

std::function< void()> | onChange
| You can assign a lambda to this callback object to have it called when the selected ID is changed.

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.
Protected Member Functions inherited from juce::SettableTooltipClient
| SettableTooltipClient ()=default

## Member Enums

## ColourIds

enum juce::ComboBox::ColourIds

A set of colour IDs to use to change the colour of various aspects of the combo box.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

To change the colours of the menu that pops up, you can set the colour IDs in PopupMenu::ColourIds.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour to fill the box with.
textColourId | The colour for the text in the box.
outlineColourId | The colour for an outline around the box.
buttonColourId | The base colour for the button (a LookAndFeel class will probably use variations on this).
arrowColourId | The colour for the arrow shape that pops up the menu.
focusedOutlineColourId | The colour that will be used to draw a box around the edge of the component when it has focus.

## Constructors and Destructors

## ComboBox()

juce::ComboBox::ComboBox | ( | const String & | componentName = {} | ) |

explicit

Creates a combo-box.

On construction, the text field will be empty, so you should call the setSelectedId() or setText() method to choose the initial value before displaying it.

Parameters

  componentName | the name to set for the component (see Component::setName())

Referenced by juce::ComboBox::Listener::comboBoxChanged(), juce::ComboBox::LookAndFeelMethods::createComboBoxTextBox(), juce::ComboBox::LookAndFeelMethods::drawComboBox(), juce::ComboBox::LookAndFeelMethods::drawComboBoxTextWhenNothingSelected(), juce::ComboBox::LookAndFeelMethods::getComboBoxFont(), juce::ComboBox::LookAndFeelMethods::getOptionsForComboBoxPopupMenu(), and juce::ComboBox::LookAndFeelMethods::positionComboBoxText().

## ~ComboBox()

juce::ComboBox::~ComboBox | ( |  | ) |

override

Destructor.

## Member Functions

## setEditableText()

void juce::ComboBox::setEditableText | ( | bool | isEditable | ) |

Sets whether the text in the combo-box is editable.

The default state for a new ComboBox is non-editable, and can only be changed by choosing from the drop-down list.

## isTextEditable()

bool juce::ComboBox::isTextEditable | ( |  | ) | const

noexcept

Returns true if the text is directly editable.

See also
  setEditableText

## setJustificationType()

void juce::ComboBox::setJustificationType | ( | Justification | justification | ) |

Sets the style of justification to be used for positioning the text.

The default is Justification::centredLeft. The text is displayed using a Label component inside the ComboBox.

References setJustificationType().

Referenced by setJustificationType().

## getJustificationType()

Justification juce::ComboBox::getJustificationType | ( |  | ) | const

noexcept

Returns the current justification for the text box.

See also
  setJustificationType

References getJustificationType().

Referenced by getJustificationType().

## addItem()

void juce::ComboBox::addItem | ( | const String & | newItemText,
|  | int | newItemId )

Adds an item to be shown in the drop-down list.

Parameters

  newItemText | the text of the item to show in the list
  newItemId | an associated ID number that can be set or retrieved - see getSelectedId() and setSelectedId(). Note that this value can not be 0!

See also
  setItemEnabled, addSeparator, addSectionHeading, getNumItems, getItemText, getItemId

References addItem().

Referenced by addItem().

## addItemList()

void juce::ComboBox::addItemList | ( | const StringArray & | items,
|  | int | firstItemIdOffset )

Adds an array of items to the drop-down list.

The item ID of each item will be its index in the StringArray + firstItemIdOffset.

References addItemList().

Referenced by addItemList().

## addSeparator()

void juce::ComboBox::addSeparator | ( |  | ) |

Adds a separator line to the drop-down list.

This is like adding a separator to a popup menu. See PopupMenu::addSeparator().

References addSeparator().

Referenced by addSeparator().

## addSectionHeading()

void juce::ComboBox::addSectionHeading | ( | const String & | headingName | ) |

Adds a heading to the drop-down list, so that you can group the items into different sections.

The headings are indented slightly differently to set them apart from the items on the list, and obviously can't be selected. You might want to add separators between your sections too.

See also
  addItem, addSeparator

References addSectionHeading().

Referenced by addSectionHeading().

## setItemEnabled()

void juce::ComboBox::setItemEnabled | ( | int | itemId,
|  | bool | shouldBeEnabled )

This allows items in the drop-down list to be selectively disabled.

When you add an item, it's enabled by default, but you can call this method to change its status.

If you disable an item which is already selected, this won't change the current selection - it just stops the user choosing that item from the list.

References setItemEnabled().

Referenced by setItemEnabled().

## isItemEnabled()

bool juce::ComboBox::isItemEnabled | ( | int | itemId | ) | const

noexcept

Returns true if the given item is enabled.

References isItemEnabled().

Referenced by isItemEnabled().

## changeItemText()

void juce::ComboBox::changeItemText | ( | int | itemId,
|  | const String & | newText )

Changes the text for an existing item.

References changeItemText().

Referenced by changeItemText().

## clear()

void juce::ComboBox::clear | ( | NotificationType | notification = sendNotificationAsync | ) |

Removes all the items from the drop-down list.

If this call causes the content to be cleared, and a change-message will be broadcast according to the notification parameter.

See also
  addItem, getNumItems

References clear(), and juce::sendNotificationAsync.

Referenced by clear(), and createAccessibilityHandler().

## getNumItems()

int juce::ComboBox::getNumItems | ( |  | ) | const

noexcept

Returns the number of items that have been added to the list.

Note that this doesn't include headers or separators.

References getNumItems().

Referenced by getNumItems().

## getItemText()

String juce::ComboBox::getItemText | ( | int | index | ) | const

Returns the text for one of the items in the list.

Note that this doesn't include headers or separators.

Parameters

  index | the item's index from 0 to (getNumItems() - 1)

References getItemText().

Referenced by getItemText().

## getItemId()

int juce::ComboBox::getItemId | ( | int | index | ) | const

noexcept

Returns the ID for one of the items in the list.

Note that this doesn't include headers or separators.

Parameters

  index | the item's index from 0 to (getNumItems() - 1)

References getItemId().

Referenced by getItemId().

## indexOfItemId()

int juce::ComboBox::indexOfItemId | ( | int | itemId | ) | const

noexcept

Returns the index in the list of a particular item ID.

If no such ID is found, this will return -1.

References indexOfItemId().

Referenced by indexOfItemId().

## getSelectedId()

int juce::ComboBox::getSelectedId | ( |  | ) | const

noexcept

Returns the ID of the item that's currently shown in the box.

If no item is selected, or if the text is editable and the user has entered something which isn't one of the items in the list, then this will return 0.

See also
  setSelectedId, getSelectedItemIndex, getText

References getSelectedId().

Referenced by getSelectedId().

## getSelectedIdAsValue()

Value & juce::ComboBox::getSelectedIdAsValue | ( |  | ) |

inline

Returns a Value object that can be used to get or set the selected item's ID.

You can call Value::referTo() on this object to make the combo box control another Value object.

References getSelectedIdAsValue().

Referenced by getSelectedIdAsValue().

## setSelectedId()

void juce::ComboBox::setSelectedId | ( | int | newItemId,
|  | NotificationType | notification = sendNotificationAsync )

Sets one of the items to be the current selection.

This will set the ComboBox's text to that of the item that matches this ID.

Parameters

  newItemId | the new item to select
  notification | determines the type of change notification that will be sent to listeners if the value changes

See also
  getSelectedId, setSelectedItemIndex, setText

References juce::sendNotificationAsync.

Referenced by createAccessibilityHandler().

## getSelectedItemIndex()

int juce::ComboBox::getSelectedItemIndex | ( |  | ) | const

Returns the index of the item that's currently shown in the box.

If no item is selected, or if the text is editable and the user has entered something which isn't one of the items in the list, then this will return -1.

See also
  setSelectedItemIndex, getSelectedId, getText

## setSelectedItemIndex()

void juce::ComboBox::setSelectedItemIndex | ( | int | newItemIndex,
|  | NotificationType | notification = sendNotificationAsync )

Sets one of the items to be the current selection.

This will set the ComboBox's text to that of the item at the given index in the list.

Parameters

  newItemIndex | the new item to select
  notification | determines the type of change notification that will be sent to listeners if the value changes

See also
  getSelectedItemIndex, setSelectedId, setText

References juce::sendNotificationAsync.

Referenced by createAccessibilityHandler().

## getText()

String juce::ComboBox::getText | ( |  | ) | const

Returns the text that is currently shown in the combo-box's text field.

If the ComboBox has editable text, then this text may have been edited by the user; otherwise it will be one of the items from the list, or possibly an empty string if nothing was selected.

See also
  setText, getSelectedId, getSelectedItemIndex

## setText()

void juce::ComboBox::setText | ( | const String & | newText,
|  | NotificationType | notification = sendNotificationAsync )

Sets the contents of the combo-box's text field.

The text passed-in will be set as the current text regardless of whether it is one of the items in the list. If the current text isn't one of the items, then getSelectedId() will return 0, otherwise it will return the appropriate ID.

Parameters

  newText | the text to select
  notification | determines the type of change notification that will be sent to listeners if the text changes

See also
  getText

References juce::sendNotificationAsync.

Referenced by createAccessibilityHandler().

## showEditor()

void juce::ComboBox::showEditor | ( |  | ) |

Programmatically opens the text editor to allow the user to edit the current item.

This is the same effect as when the box is clicked-on.

See also
  Label::showEditor();

## showPopup()

virtual void juce::ComboBox::showPopup | ( |  | ) |

virtual

Pops up the combo box's list.

This is virtual so that you can override it with your own custom popup mechanism if you need some really unusual behaviour.

## hidePopup()

void juce::ComboBox::hidePopup | ( |  | ) |

Hides the combo box's popup list, if it's currently visible.

## isPopupActive()

bool juce::ComboBox::isPopupActive | ( |  | ) | const

inline noexcept

Returns true if the popup menu is currently being shown.

## getRootMenu() [1/2]

PopupMenu * juce::ComboBox::getRootMenu | ( |  | ) |

inline noexcept

Returns the PopupMenu object associated with the ComboBox.

Can be useful for adding sub-menus to the ComboBox standard PopupMenu

## getRootMenu() [2/2]

const PopupMenu * juce::ComboBox::getRootMenu | ( |  | ) | const

inline noexcept

Returns the PopupMenu object associated with the ComboBox.

## addListener()

void juce::ComboBox::addListener | ( | Listener * | listener | ) |

Registers a listener that will be called when the box's content changes.

## removeListener()

void juce::ComboBox::removeListener | ( | Listener * | listener | ) |

Deregisters a previously-registered listener.

## setTextWhenNothingSelected()

void juce::ComboBox::setTextWhenNothingSelected | ( | const String & | newMessage | ) |

Sets a message to display when there is no item currently selected.

See also
  getTextWhenNothingSelected

## getTextWhenNothingSelected()

String juce::ComboBox::getTextWhenNothingSelected | ( |  | ) | const

Returns the text that is shown when no item is selected.

See also
  setTextWhenNothingSelected

## setTextWhenNoChoicesAvailable()

void juce::ComboBox::setTextWhenNoChoicesAvailable | ( | const String & | newMessage | ) |

Sets the message to show when there are no items in the list, and the user clicks on the drop-down box.

By default it just says "no choices", but this lets you change it to something more meaningful.

## getTextWhenNoChoicesAvailable()

String juce::ComboBox::getTextWhenNoChoicesAvailable | ( |  | ) | const

Returns the text shown when no items have been added to the list.

See also
  setTextWhenNoChoicesAvailable

## setTooltip()

void juce::ComboBox::setTooltip | ( | const String & | newTooltip | ) |

override virtual

Gives the ComboBox a tooltip.

Reimplemented from juce::SettableTooltipClient.

## setScrollWheelEnabled()

void juce::ComboBox::setScrollWheelEnabled | ( | bool | enabled | ) |

noexcept

This can be used to allow the scroll-wheel to nudge the chosen item.

By default it's disabled, and I'd recommend leaving it disabled if there's any chance that the control might be inside a scrollable list or viewport.

## enablementChanged()

void juce::ComboBox::enablementChanged | ( |  | ) |

override virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from juce::Component.

## colourChanged()

void juce::ComboBox::colourChanged | ( |  | ) |

override virtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChange

Reimplemented from juce::Component.

## focusGained()

void juce::ComboBox::focusGained | ( | Component::FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## focusLost()

void juce::ComboBox::focusLost | ( | Component::FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## handleAsyncUpdate()

void juce::ComboBox::handleAsyncUpdate | ( |  | ) |

override virtual

Called back to do whatever your class needs to do.

This method is called by the message thread at the next convenient time after the triggerAsyncUpdate() method has been called.

Implements juce::AsyncUpdater.

## getTooltip()

String juce::ComboBox::getTooltip | ( |  | ) |

inline override virtual

Returns the string that this object wants to show as its tooltip.

Implements juce::TooltipClient.

## mouseDown()

void juce::ComboBox::mouseDown | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseDrag()

void juce::ComboBox::mouseDrag | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::MouseListener.

## mouseUp()

void juce::ComboBox::mouseUp | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseWheelMove()

void juce::ComboBox::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel )

override virtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them.

Parameters

  event | details about the mouse event
  wheel | details about the wheel movement

Reimplemented from juce::MouseListener.

## lookAndFeelChanged()

void juce::ComboBox::lookAndFeelChanged | ( |  | ) |

override virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## paint()

void juce::ComboBox::paint | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## resized()

void juce::ComboBox::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## keyStateChanged()

bool juce::ComboBox::keyStateChanged | ( | bool | isKeyDown | ) |

override virtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## keyPressed()

bool juce::ComboBox::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## valueChanged()

void juce::ComboBox::valueChanged | ( | Value & | value | ) |

override virtual

Called when a Value object is changed.

Note that the Value object passed as a parameter may not be exactly the same object that you registered the listener with - it might be a copy that refers to the same underlying ValueSource. To find out, you can call Value::refersToSameSourceAs().

Implements juce::Value::Listener.

## parentHierarchyChanged()

void juce::ComboBox::parentHierarchyChanged | ( |  | ) |

override virtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, this method will be called on all of its children (recursively - so all children of its children will also be called as well).

Subclasses can override this if they need to react to this in some way.

See also
  getParentComponent, isShowing, ComponentListener::componentParentHierarchyChanged

Reimplemented from juce::Component.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::ComboBox::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

References clear(), setSelectedId(), setSelectedItemIndex(), and setText().

## Member Data Documentation

## onChange

std::function<void()> juce::ComboBox::onChange

You can assign a lambda to this callback object to have it called when the selected ID is changed.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited